'Insert absolute page numbers where you've called for them (by Abe Hendin)
'InsertAbsPN.csc
'
'Copyright 2002 by Abe Hendin <venturascript@yourspeed.com>. Public Domain.
'Release 1.0, September 9, 2002
'
'Updated for Ventura 10 on November 17, 2002.
'
'This simple script looks for two markers (best placed on a page tag), on every page
'on which they appear, and inserts the absolute page number (i.e., the value of
'the page counter). The markers it looks for are "AbsPNBeg" and "AbsPNEnd". Use my
'supporting "InsertAbsPNMarkers" script to insert these two markers with one
'click/shortcut.
'
'You can rerun this script whenever the pagination changes: it will automatically
'remove an existing page number between the markers before inserting the current
'page number.
'
'KNOWN ISSUES:
'The script doesn't include any error checking. If you accidentally delete one
'of the AbsPNEnd markers, it will loop until it reaches the next AbsPNEnd marker
'or the end of the current text file, whichever comes first, and something
'won't be right.
'
'Since inserting the page numbers overrides the page tags, if you remove the
'overrides later you'll also remove the absolute page numbers. Just rerun
'this script after you're done reapplying page tags.
'
'Please let me know if it helps you, or if you improve on it.

WITHOBJECT "CorelVentura.Automation.10"

Dim AbsPNBeg As String
Dim CurrPN As String
Dim Found As Boolean
Dim TestChar As Long
Dim MN As String

AbsPNBeg = "<$M[AbsPNBeg]>"

	.ViewPageLayout 'set view to enable full searching
	.ViewGotoPage .GoWhere = 0 'start from first page of pub
	.FrameFirstLine 'plant cursor for find operation

	'find AbsPNBeg marker
	.EditInitFindText AbsPNBeg, .Reset = True
	Found = .EditFindText()

	Do While Found
		.TextCharRight 1 'move past marker to test for AbsPNEnd marker
		TestChar = .TextSpecialItemType()
		Do While TestChar <> 9 'until end marker found, keep looking
			.TextCharRight 1, True 'select the non-marker character
			.EditDelete 'delete the non-marker character
			TestChar = .TextSpecialItemType()
		Loop
	
		If TestChar = 9 Then
			.MarkerGet MN
			If MN = "AbsPNEnd" Then
				CurrPN = Ltrim(Str(.CurrentPageNumber(, 2))) 'get absolute page number as string
				.TypeText CurrPN
				.TextCharRight 1
			Else
				.TextCharRight 1
			End If
		End If
		Found = .EditFindText()
	Loop
	.EditInitFindText .Reset = True
END WITHOBJECT
